# Copyright  2004-2022, Stefan Kanthak <stefan.kanthak@nexgo.de>

# * The software is provided "as is" without any warranty, neither express
#   nor implied.
# * In no event will the author be held liable for any damage(s) arising
#   from the use of the software.
# * Redistribution of the software is allowed only in unmodified form.
# * Permission is granted to use the software solely for personal private
#   and non-commercial purposes.
# * An individuals use of the software in his or her capacity or function
#   as an agent, (independent) contractor, employee, member or officer of
#   a business, corporation or organization (commercial or non-commercial)
#   does not qualify as personal private and non-commercial purpose.
# * Without written approval from the author the software must not be used
#   for a business, for commercial, corporate, governmental, military or
#   organizational purposes of any kind, or in a commercial, corporate,
#   governmental, military or organizational environment of any kind.

# https://technet.microsoft.com/en-us/library/2269637.aspx
# https://support.microsoft.com/en-us/kb/2269637
# https://support.microsoft.com/en-us/kb/2533623

.SUFFIXES:

all: _2533623.EXE

clean:
	ERASE _2533623.EXP _2533623.LCU _2533623.OBJ _2533623.TMP

clobber: clean
	ERASE _2533623.EXE _2533623.H _2533623.LIB

_2533623.H: _2533623.MAK
	Rem <<$@
// Copyleft  2011-2022, Stefan Kanthak <stefan.kanthak@nexgo.de>

#pragma once

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)
#pragma comment(linker, "/DEFAULTLIB:_2533623.LIB")

// https://msdn.microsoft.com/en-us/library/ms684179.aspx
// https://msdn.microsoft.com/en-us/library/hh310515.aspx

#define LOAD_LIBRARY_SEARCH_DLL_LOAD_DIR	0x00000100UL
#define LOAD_LIBRARY_SEARCH_APPLICATION_DIR	0x00000200UL
#define LOAD_LIBRARY_SEARCH_USER_DIRS		0x00000400UL
#define LOAD_LIBRARY_SEARCH_SYSTEM32		0x00000800UL
#define LOAD_LIBRARY_SEARCH_DEFAULT_DIRS	0x00001000UL

typedef	LPVOID	DLL_DIRECTORY_COOKIE;

// https://msdn.microsoft.com/en-us/library/hh310513.aspx

__declspec(dllimport)
DLL_DIRECTORY_COOKIE	WINAPI	AddDllDirectory(LPCWSTR NewDirectory);

// https://msdn.microsoft.com/en-us/library/hh310514.aspx

__declspec(dllimport)
BOOL	WINAPI	RemoveDllDirectory(DLL_DIRECTORY_COOKIE Cookie);

// https://msdn.microsoft.com/en-us/library/hh310515.aspx

__declspec(dllimport)
BOOL	WINAPI	SetDefaultDllDirectories(DWORD DirectoryFlags);
<<NOKEEP

_2533623.TMP: _2533623.MAK
	CL.EXE /Brepro /c /Fo$@ /Gz /nologo /Tc<< /W4 /wd4100 /Zl
// Copyleft  2011-2022, Stefan Kanthak <stefan.kanthak@nexgo.de>

__declspec(dllexport)
void *	AddDllDirectory(void *_1)
{ return 0; }

__declspec(dllexport)
int	RemoveDllDirectory(void *_1)
{ return 0; }

__declspec(dllexport)
int	SetDefaultDllDirectories(long _1)
{ return 0; }
<<NOKEEP

_2533623.LIB: _2533623.TMP
	LINK.EXE /LIB /BREPRO /DEF /EXPORT:AddDllDirectory /EXPORT:RemoveDllDirectory /EXPORT:SetDefaultDllDirectories /NAME:KERNEL32 /NODEFAULTLIB /NOLOGO /OUT:$@ $**

_2533623.LCU: _2533623.H
	CL.EXE /Brepro /c /Fo$@ /I. /nologo /Tc<< /W4 /wd4047 /Zl
// Copyright  2004-2022, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)

#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <windows.h>
#include "$**"

// https://msdn.microsoft.com/en-us/library/cc779664.aspx
// https://msdn.microsoft.com/en-us/library/ff549646.aspx

#define FLG_STOP_ON_EXCEPTION		0x00000001UL
#define FLG_SHOW_LDR_SNAPS		0x00000002UL
#define FLG_DEBUG_INITIAL_COMMAND	0x00000004UL
#define FLG_STOP_ON_HUNG_GUI		0x00000008UL
#define FLG_HEAP_ENABLE_TAIL_CHECK	0x00000010UL
#define FLG_HEAP_ENABLE_FREE_CHECK	0x00000020UL
#define FLG_HEAP_VALIDATE_PARAMETERS	0x00000040UL
#define FLG_HEAP_VALIDATE_ALL		0x00000080UL
#define FLG_APPLICATION_VERIFIER	0x00000100UL
#define FLG_MONITOR_SILENT_PROCESS_EXIT	0x00000200UL
#define FLG_POOL_ENABLE_TAGGING		0x00000400UL
#define FLG_HEAP_ENABLE_TAGGING		0x00000800UL
#define FLG_USER_STACK_TRACE_DB		0x00001000UL
#define FLG_KERNEL_STACK_TRACE_DB	0x00002000UL
#define FLG_MAINTAIN_OBJECT_TYPELIST	0x00004000UL
#define FLG_HEAP_ENABLE_TAG_BY_DLL	0x00008000UL
#define FLG_DISABLE_STACK_EXTENSION	0x00010000UL
#define FLG_ENABLE_CSRDEBUG		0x00020000UL
#define FLG_ENABLE_KDEBUG_SYMBOL_LOAD	0x00040000UL
#define FLG_DISABLE_PAGE_KERNEL_STACKS	0x00080000UL
#define FLG_ENABLE_SYSTEM_CRIT_BREAKS	0x00100000UL
#define FLG_HEAP_DISABLE_COALESCING	0x00200000UL
#define FLG_ENABLE_CLOSE_EXCEPTIONS	0x00400000UL
#define FLG_ENABLE_EXCEPTION_LOGGING	0x00800000UL
#define FLG_ENABLE_HANDLE_TYPE_TAGGING	0x01000000UL
#define FLG_HEAP_PAGE_ALLOCS		0x02000000UL
#define FLG_DEBUG_INITIAL_COMMAND_EX	0x04000000UL
#define FLG_DISABLE_DBGPRINT		0x08000000UL
#define FLG_CRITSEC_EVENT_CREATION	0x10000000UL
#define FLG_STOP_ON_UNHANDLED_EXCEPTION	0x20000000UL
#define FLG_ENABLE_HANDLE_EXCEPTIONS	0x40000000UL
#define FLG_DISABLE_PROTDLLS		0x80000000UL

#ifndef _WIN64
static	DWORD	__security_cookie = 0xBB40E64EUL;
		               // = 3141592654 = 10**9 * pi

// https://msdn.microsoft.com/en-us/library/9a89h429.aspx

extern	LPVOID	__safe_se_handler_table[];
extern	BYTE	__safe_se_handler_count;

// https://msdn.microsoft.com/en-us/library/ms680328.aspx

const	struct	_IMAGE_LOAD_CONFIG_DIRECTORY_32
{
	DWORD	Size;
	DWORD	TimeDateStamp;
	WORD	MajorVersion;
	WORD	MinorVersion;
	DWORD	GlobalFlagsClear;
	DWORD	GlobalFlagsSet;
	DWORD	CriticalSectionDefaultTimeout;
	DWORD	DeCommitFreeBlockThreshold;
	DWORD	DeCommitTotalFreeThreshold;
	DWORD	LockPrefixTable;
	DWORD	MaximumAllocationSize;
	DWORD	VirtualMemoryThreshold;
	DWORD	ProcessHeapFlags;
	DWORD	ProcessAffinityMask;
	WORD	CSDVersion;
	WORD	DependentLoadFlags;
	DWORD	EditList;
	DWORD	SecurityCookie;
	DWORD	SEHandlerTable;
	DWORD	SEHandlerCount;
	DWORD	GuardCFCheckFunctionPointer;
	DWORD	GuardCFDispatchFunctionPointer;
	DWORD	GuardCFFunctionTable;
	DWORD	GuardCFFunctionCount;
	DWORD	GuardFlags;
} _load_config_used = {sizeof(_load_config_used),
                       'SNAP',		// = 2014-04-16 08:37:16 UTC
                       _MSC_VER / 100,
                       _MSC_VER % 100,
                       0UL,
                       FLG_SHOW_LDR_SNAPS,
                       0UL, 0UL, 0UL, 0UL, 0UL, 0UL,
                       HEAP_GENERATE_EXCEPTIONS,
                       0UL,
                       0U,
                       LOAD_LIBRARY_SEARCH_SYSTEM32,
                       0UL,
                       &__security_cookie,
                       __safe_se_handler_table,
                       &__safe_se_handler_count,
                       0UL, 0UL, 0UL, 0UL, 0UL};
#else
static	DWORD64	__security_cookie = 0x00002B992DDFA232ULL;
		               // = 3141592653589793241 >> 16
		               // = 10**18 / 2**16 * pi

// https://msdn.microsoft.com/en-us/library/ms680328.aspx

const	struct	_IMAGE_LOAD_CONFIG_DIRECTORY_64
{
	DWORD	Size;
	DWORD	TimeDateStamp;
	WORD	MajorVersion;
	WORD	MinorVersion;
	DWORD	GlobalFlagsClear;
	DWORD	GlobalFlagsSet;
	DWORD	CriticalSectionDefaultTimeout;
	DWORD64	DeCommitFreeBlockThreshold;
	DWORD64	DeCommitTotalFreeThreshold;
	DWORD64	LockPrefixTable;
	DWORD64	MaximumAllocationSize;
	DWORD64	VirtualMemoryThreshold;
	DWORD64	ProcessAffinityMask;
	DWORD	ProcessHeapFlags;
	WORD	CSDVersion;
	WORD	DependentLoadFlags;
	DWORD64	EditList;
	DWORD64	SecurityCookie;
	DWORD64	SEHandlerTable;
	DWORD64	SEHandlerCount;
	DWORD64	GuardCFCheckFunctionPointer;
	DWORD64	GuardCFDispatchFunctionPointer;
	DWORD64	GuardCFFunctionTable;
	DWORD64	GuardCFFunctionCount;
	DWORD	GuardFlags;
} _load_config_used = {sizeof(_load_config_used),
                       'SNAP',		// = 2014-04-16 08:37:16 UTC
                       _MSC_VER / 100,
                       _MSC_VER % 100,
                       0UL,
                       FLG_SHOW_LDR_SNAPS,
                       0UL,
                       0ULL, 0ULL, 0ULL, 0ULL, 0ULL, 0ULL,
                       HEAP_GENERATE_EXCEPTIONS,
                       0U,
                       LOAD_LIBRARY_SEARCH_SYSTEM32,
                       0ULL,
                       &__security_cookie,
                       0ULL, 0ULL, 0ULL, 0ULL, 0ULL, 0ULL,
                       0UL};
#endif // _WIN64
<<NOKEEP

_2533623.OBJ: _2533623.H
	CL.EXE /Brepro /c /Fo$@ /GAFwy /I. /nologo /Ox /Tc<< /W4 /wd4013 /Zl
// Copyright  2004-2022, Stefan Kanthak <stefan.kanthak@nexgo.de>

#define _WIN32_WINNT	0x0500

#include <windows.h>
#include "$**"

__forceinline
HRESULT	WINAPI	se2hr(INT se)
{
	if (se > 32)
		return ERROR_SUCCESS;

	switch (se)
	{
	case 0:
		return ERROR_OUTOFMEMORY;
#if 0
	case SE_ERR_FNF:		// 2
		return ERROR_FILE_NOT_FOUND;

	case SE_ERR_PNF:		// 3
		return ERROR_PATH_NOT_FOUND;

	case SE_ERR_ACCESSDENIED:	// 5
		return ERROR_ACCESS_DENIED;

	case SE_ERR_OOM:		// 8
		return ERROR_NOT_ENOUGH_MEMORY;
#else
	case SE_ERR_FNF:		// 2
	case SE_ERR_PNF:		// 3
	case SE_ERR_ACCESSDENIED:	// 5
	case SE_ERR_OOM:		// 8
	case ERROR_BAD_FORMAT:		// 11
		return (HRESULT) se;
#endif
	case SE_ERR_SHARE:		// 26
		return ERROR_SHARING_VIOLATION;

	case SE_ERR_DDETIMEOUT:		// 28
	case SE_ERR_DDEFAIL:		// 29
	case SE_ERR_DDEBUSY:		// 30
		return ERROR_DDE_FAIL;

	case SE_ERR_ASSOCINCOMPLETE:	// 27
	case SE_ERR_NOASSOC:		// 31
		return ERROR_NO_ASSOCIATION;

	case SE_ERR_DLLNOTFOUND:	// 32
		return ERROR_DLL_NOT_FOUND;

	default:
		return ~0UL;
	}
}

__declspec(noreturn)
VOID	WINAPI	wWinMainCRTStartup(VOID)
{
	HRESULT	hr;

	// https://msdn.microsoft.com/en-us/library/bb759784.aspx

	SHELLEXECUTEINFOW	sei = {sizeof(sei),
				       SEE_MASK_NOASYNC,
				       HWND_DESKTOP,
				       NULL,
				       L"..",
				       NULL,
				       NULL,
				       SW_SHOWNORMAL,
				       NULL,
				       NULL,
				       NULL,
				       HKEY_CLASSES_ROOT,
				       0UL,
				       NULL,
				       NULL};
#if 1
	// https://msdn.microsoft.com/en-us/library/hh310515.aspx

	if (!SetDefaultDllDirectories(LOAD_LIBRARY_SEARCH_SYSTEM32))

		// https://msdn.microsoft.com/en-us/library/ms679360.aspx

		hr = GetLastError();
	else
#endif
	{	// https://msdn.microsoft.com/en-us/library/ms695279.aspx

		hr = CoInitializeEx(NULL, COINIT_APARTMENTTHREADED | COINIT_DISABLE_OLE1DDE);

		if (hr == S_OK)
#if 0
			// https://msdn.microsoft.com/en-us/library/bb762153.aspx

			hr = se2hr(ShellExecuteW(NULL, NULL, L"..", NULL, NULL, SW_SHOWNORMAL));
#else
			// https://msdn.microsoft.com/en-us/library/bb762154.aspx

			if (!ShellExecuteExW(&sei))
				hr = GetLastError();
#endif
#if 0
		else
			if (HRESULT_FACILITY(hr) == FACILITY_WIN32)
				hr = HRESULT_CODE(hr);
#endif
		// https://msdn.microsoft.com/en-us/library/ms688715.aspx

		CoUninitialize();
	}

	// https://msdn.microsoft.com/en-us/library/ms682658.aspx

	ExitProcess(hr);
}
<<NOKEEP

_2533623.EXE: _2533623.LIB _2533623.LCU _2533623.OBJ
	LINK.EXE /LINK /BREPRO /DYNAMICBASE /ENTRY:wWinMainCRTStartup /LARGEADDRESSAWARE /MERGE:.rdata=.const /MERGE:.text=.code /NOCOFFGRPINFO /NODEFAULTLIB /NOLOGO /NXCOMPAT /OPT:REF /OSVERSION:6.0 /OUT:$@ /RELEASE /SUBSYSTEM:WINDOWS /SWAPRUN:CD,NET /VERSION:0.815 $** KERNEL32.LIB OLE32.LIB SHELL32.LIB
